## js-of-ocaml 1.0.2+dfsg

=== Makefile ===

all: check_lwt compiler library doc runtime examples

include Makefile.conf

.PHONY: compiler library runtime examples check_lwt doc

compiler:
	$(MAKE) -C compiler
library:
	$(MAKE) -C lib
runtime:
	$(MAKE) -C runtime
toplevel: compiler library runtime
	$(MAKE) -C toplevel
examples: compiler library runtime
	$(MAKE) -C examples
tests: compiler library
	$(MAKE) -C tests
doc: library
	$(MAKE) -C doc

LWTERROR="Js_of_ocaml requires Lwt version 2.3.0 at least.  Please upgrade."
check_lwt:
	@if ocamlfind query lwt -l | ocaml tools/check_version.ml 2.3.0; then \
	  echo $(LWTERROR); exit 1; \
	fi

include Makefile.filelist

VERSION := $(shell head -n 1 VERSION)
install:
	ocamlfind install -patch-version ${VERSION} $(LIBRARY) lib/META $(INTF) $(IMPL) $(NATIMPL) $(OTHERS)
	install -d -m 755 $(BINDIR)
	install $(BIN) $(BINDIR)

uninstall:
	ocamlfind remove $(LIBRARY)
	rm -f $(BINDIR)/$(COMPILER)

reinstall: uninstall install

depend:
	$(MAKE) -C compiler depend
	$(MAKE) -C lib depend

clean:
	$(MAKE) -C compiler clean
	$(MAKE) -C lib clean
	$(MAKE) -C runtime clean
	$(MAKE) -C examples clean
ifeq ($(wildcard tests),tests)
	$(MAKE) -C tests clean
	$(MAKE) -C doc clean
endif

realclean: clean
	find . -name "*~" -print | xargs rm -f

dist:
	rm -rf /tmp/js_of_ocaml-${VERSION} &&\
        cd /tmp &&\
	darcs get http://ocsigen.org/darcs/js_of_ocaml/ js_of_ocaml-${VERSION} &&\
	tar zcvf js_of_ocaml-${VERSION}.tar.gz js_of_ocaml-${VERSION} --exclude benchmarks --exclude _darcs --exclude tests

=== compiler/Makefile ===

include ../Makefile.conf

all: $(COMPILER)

OBJS=util.cmx dgraph.cmx \
     javascript.cmx js_output.cmx js_simpl.cmx \
     instr.cmx code.cmx primitive.cmx subst.cmx pure_fun.cmx deadcode.cmx \
     flow.cmx inline.cmx \
     tailcall.cmx freevars.cmx phisimpl.cmx \
     linker.cmx generate.cmx parse.cmx driver.cmx

COMPOBJS=$(OBJS) main.cmx

compile: $(COMPOBJS:cmx=cmo)
	ocamlfind ocamlc -package findlib,str -linkpkg -o $@ $^

$(COMPILER): $(COMPOBJS)
	ocamlfind ocamlopt -package findlib,str -linkpkg -o $@ $^

compiler.cma: $(OBJS:cmx=cmo)
	ocamlfind ocamlc -a -o $@ $^

%.cmx: %.ml
	ocamlfind ocamlopt -package findlib,str -c $<

%.cmo: %.ml
	ocamlfind ocamlc -package findlib,str -c $<

%.cmi: %.mli
	ocamlfind ocamlc -package findlib,str -c $<

clean:
	rm -f *.cm[aiox] *.o
	rm -f js_of_ocaml compile

depend:
	ocamldep *.ml *.mli > .depend

include .depend

=== doc/Makefile ===

include ../Makefile.conf
include ../Makefile.filelist

MLIS := ${addprefix ../, ${DOC}}

.PHONY: doc
doc: api-html/index.html
api-html/index.html: ${MLIS} api-index
	mkdir -p api-html
	ocamlfind ocamldoc -package lwt -intro api-index -html \
	   -d api-html -I ../lib -I ../lib/deriving_json ${MLIS}

clean:
	rm -r api-html/*

=== lib/Makefile ===
MLOBJS= js.cmo dom.cmo dom_html.cmo dom_events.cmo lwt_js.cmo firebug.cmo regexp.cmo url.cmo file.cmo form.cmo xmlHttpRequest.cmo event_arrows.cmo json.cmo
MLINTFS= $(MLOBJS:.cmo=.mli)
COBJS= stubs.o
OBJS=$(MLOBJS) $(COBJS)

JSON_OBJS=$(addprefix deriving_json/,deriving_bi_outbuf.cmo deriving_Json_lexer.cmo deriving_Json.cmo)

include ../Makefile.conf

ifneq "${DERIVING}" ""
PA_DERIVING=syntax/pa_deriving_Json.cmo
DERIVING_JSON=deriving_json.cma deriving_json.cmxs
endif

all: $(LIBNAME).cma syntax/pa_js.cmo ${PA_DERIVING} ${DERIVING_JSON}

$(LIBNAME).cma: $(OBJS)
	ocamlmklib -o $(LIBNAME) $(OBJS)

deriving_json.cma: $(JSON_OBJS)
	ocamlfind ocamlc -a -o $@ $^

deriving_json.cmxa: $(JSON_OBJS:.cmo=.cmx)
	ocamlfind ocamlopt -a -o $@ $^
deriving_json.cmxs: deriving_json.cmxa
	ocamlfind ocamlopt -shared -linkall -o $@ $^

syntax/pa_js.cmo: syntax/pa_js.ml
	ocamlfind ocamlc -package camlp4.extend,camlp4.quotations -syntax camlp4o -c $<

syntax/pa_deriving_Json.cmo: syntax/pa_deriving_Json.ml
	ocamlfind ocamlc -package deriving-ocsigen,camlp4.quotations.o -syntax camlp4o -c $<

%.cmo: %.ml syntax/pa_js.cmo
	ocamlfind ocamlc -pp "camlp4o syntax/pa_js.cmo" -package lwt -c -g $<

%.cmi: %.mli
	ocamlfind ocamlc -package lwt -I deriving_json -c $<

%.ml: %.mll
	ocamllex $<

${JSON_OBJS}: %.cmo: %.ml ${PA_DERIVING}
	ocamlfind ocamlc -package deriving-ocsigen.syntax -syntax camlp4o -ppopt ${PA_DERIVING} -I deriving_json -c $<

${JSON_OBJS:.cmo=.cmx}: %.cmx: %.ml ${PA_DERIVING}
	ocamlfind ocamlopt -package deriving-ocsigen.syntax -syntax camlp4o -ppopt ${PA_DERIVING} -I deriving_json -c $<


%.o: %.c
	ocamlfind ocamlc -package lwt -c $<

stubs.c: $(MLOBJS:cmo=ml)
	(echo "#include <stdlib.h>"; \
	 echo "#include <stdio.h>"; \
	 echo "#define D(f) void f () { fprintf(stderr, \"Unimplemented Javascript primitive %s!\\\\n\", #f); exit(1); }"; \
	 (sed -n -e 's/.*external.*"\([^"%]*\)".*/D(\1)/p' $(MLOBJS:cmo=ml) | \
	  sort | uniq)) \
        > stubs.c

clean:
	rm -f *.cm[ioa] *.[ao] *.so
	rm -f syntax/*.cm[io]
	rm -f deriving_json/*.cm[ioa] deriving_json/*.[ao] deriving_json/*.so
	rm -f deriving_json/deriving_Json_lexer.ml
	rm -f stubs.c

depend: syntax/pa_js.cmo ${PA_DERIVING}
	ocamldep -pp "camlp4o syntax/pa_js.cmo" *.ml *.mli > .depend
ifneq "${DERIVING}" ""
	${MAKE} --no-print-directory deriving_json/deriving_Json_lexer.ml
	ls deriving_json/*.mli deriving_json/*.ml | \
	  grep -v deriving_Json_stdlib.mli | \
	  xargs ocamlfind ocamldep -I deriving_json -package deriving-ocsigen.syntax -syntax camlp4o -ppopt ${PA_DERIVING} >> .depend
	@# camlp4 3.12.0 fails on (module type of ...)
	ocamldep -I deriving_json deriving_json/deriving_Json_stdlib.mli  >> .depend
endif

include .depend

=== runtime/Makefile ===
FILES= 	mlString.js ieee_754.js int64.js md5.js marshall.js \
	lexing.js parsing.js \
	stdlib.js jslib.js jslib_js_of_ocaml.js

runtime.js: $(FILES)
	cat $(FILES) > runtime.js

clean:
	rm -f runtime.js

=== toplevel/Makefile ===

NAME=toplevel
OBJS=toplevel.cmo

all: $(NAME).js

include ../Makefile.conf
COMP=../compiler/$(COMPILER)
JSFILES=../runtime/runtime.js ../runtime/weak.js toplevel_runtime.js
OCAMLC=ocamlfind ocamlc -package lwt,str -pp "camlp4o ../lib/syntax/pa_js.cmo" -I ../lib -I ../compiler
STDLIB= ../lib/$(LIBNAME).cma ../compiler/compiler.cma toplevellib.cma

# Removed gc and sys
STDLIB_MODULES=\
  arg \
  array \
  arrayLabels \
  buffer \
  callback \
  camlinternalLazy \
  camlinternalMod \
  camlinternalOO \
  char \
  complex \
  digest \
  filename \
  format \
  genlex \
  hashtbl \
  int32 \
  int64 \
  lazy \
  lexing \
  list \
  listLabels \
  map \
  marshal \
  moreLabels \
  nativeint \
  obj \
  oo \
  parsing \
  pervasives \
  printexc \
  printf \
  queue \
  random \
  scanf \
  set \
  sort \
  stack \
  stdLabels \
  stream \
  string \
  stringLabels \
  weak
PERVASIVES=$(STDLIB_MODULES) outcometree topdirs toploop

#toplevel.byte: $(OBJS:cmx=cmo) toplevel.cmo
#	ocamlfind ocamlc -linkall -g -package str -linkpkg toplevellib.cma -o $@.tmp $^

$(NAME).js: $(NAME).byte $(COMP) $(JSFILES)
	$(COMP) -toplevel -noinline -noruntime $(JSFILES) $(NAME).byte $(OPTIONS)

$(NAME).byte: $(OBJS) ../compiler/compiler.cma
	$(OCAMLC) -linkall -package str -linkpkg -o $@.tmp $(STDLIB) $(OBJS)
	/usr/lib/ocaml/expunge $@.tmp $@ $(PERVASIVES)
	rm -f $@.tmp

%.cmo: %.ml
	$(OCAMLC) -c $<

%.cmi: ../compiler/compiler.cma

../compiler/compiler.cma:
	$(MAKE) -C ../compiler compiler.cma

errors.cmi: errors.mli
	$(OCAMLC) -c $<

clean::
	rm -f *.cm[io] $(NAME).byte $(NAME).js

depend:
	ocamldep -pp "camlp4o ../lib/syntax/pa_js.cmo" -I ../compiler *.ml *.mli > .depend

include .depend

=== debian/changelog ===
js-of-ocaml (1.0.2+dfsg-1) unstable; urgency=low

  * New upstream release
    - Bump required Lwt version to 2.3.0
    - Update license to LGPLv2
    - Drop patches (fixed upstream)
  * Bump Standards-Version to 3.9.2 (no changes)

 -- Nicolas Dandrimont <nicolas.dandrimont@crans.org>  Fri, 20 May 2011 00:33:08 +0200

js-of-ocaml (1.0+dfsg-2) unstable; urgency=low

  * Team upload.
  * Do not compile native js_of_ocaml on bytecode architectures, use bytecode
    version instead.

 -- Mehdi Dogguy <mehdi@debian.org>  Sat, 23 Apr 2011 13:39:26 +0200

js-of-ocaml (1.0+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #610392)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 23 Jan 2011 12:40:04 +0100

=== debian/control ===
Source: js-of-ocaml
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stéphane Glondu <glondu@debian.org>, Nicolas Dandrimont <nicolas.dandrimont@crans.org>
Build-Depends:
 debhelper (>= 8),
 dh-ocaml (>= 0.9~),
 ocaml-findlib,
 liblwt-ocaml-dev (>= 2.3.0~),
 camlp4,
 ocaml-nox (>= 3.12.0~)
Standards-Version: 3.9.2
Homepage: http://ocsigen.org/js_of_ocaml
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/js-of-ocaml.git
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/js-of-ocaml.git

Package: libjs-of-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: OCaml bytecode to JavaScript compiler
 Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
 it possible to run OCaml programs in a web browser. Its key features
 are the following:
  * the whole language, and most of the standard library are
    supported;
  * the generated code can be used with any web server and browser;
  * you can use a standard installation of OCaml to compile your
    programs. In particular, you do not have to recompile a library to
    use it with Js_of_ocaml. You just have to link your program with a
    specific library to interface with the browser APIs.
 .
 This package contains the compiler itself.

Package: libjs-of-ocaml-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: OCaml bytecode to JavaScript compiler (documentation)
 Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
 it possible to run OCaml programs in a web browser.
 .
 This package contains the API reference and examples.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DESTDIR=$(CURDIR)/debian/tmp
BINDIR=$(DESTDIR)/usr/bin
DOCDIR=$(DESTDIR)/usr/share/doc/libjs-of-ocaml-dev
COMPILER=$(shell awk '/COMPILER/{print $$NF}' Makefile.conf)

include /usr/share/ocaml/ocamlvars.mk

export OCAMLFIND_DESTDIR=$(DESTDIR)/$(OCAML_STDLIB_DIR)
export OCAMLFIND_LDCONF=ignore

%:
	dh $@ --with ocaml

.PHONY: override_dh_auto_build
override_dh_auto_build:
ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
	make -C compiler
else
	make -C compiler compile
	mv compiler/compile compiler/$(COMPILER)
endif
	make library runtime doc

.PHONY: override_dh_install
override_dh_install:
	dh_install -X.owner --list-missing

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress -X.js

.PHONY: override_dh_auto_install
override_dh_auto_install:
	mkdir -p $(OCAMLFIND_DESTDIR) $(BINDIR) $(DESTDIR)$(OCAML_DLL_DIR)
	$(MAKE) install BINDIR=$(BINDIR)
	mkdir -p $(DOCDIR)/html $(DOCDIR)/examples
	cp -a doc/api-html $(DOCDIR)/html/api
	cp -a examples/* $(DOCDIR)/examples
	rm -f $(DOCDIR)/examples/*/*.cm* $(DOCDIR)/examples/*/*.byte

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	dh_auto_clean
	-cd $(CURDIR)/doc && make clean

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d*$// \
http://ocsigen.org/js_of_ocaml/install ../download/js_of_ocaml-(.*)\.tar\.gz
# Upstream darcs repository:
#   http://ocsigen.org/darcs/js_of_ocaml/
#   http://ocsigen.org/darcsweb/?r=js_of_ocaml;a=summary

## js-of-ocaml 1.0.5

=== lib/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-MLOBJS= js.cmo dom.cmo dom_html.cmo dom_events.cmo lwt_js.cmo firebug.cmo regexp.cmo url.cmo file.cmo form.cmo xmlHttpRequest.cmo event_arrows.cmo json.cmo
+MLOBJS= js.cmo dom.cmo dom_html.cmo dom_events.cmo lwt_js.cmo firebug.cmo regexp.cmo CSS.cmo url.cmo file.cmo form.cmo xmlHttpRequest.cmo event_arrows.cmo json.cmo
 MLINTFS= $(MLOBJS:.cmo=.mli)
 COBJS= stubs.o
 OBJS=$(MLOBJS) $(COBJS)
@@ -6,6 +6,7 @@
 JSON_OBJS=$(addprefix deriving_json/,deriving_bi_outbuf.cmo deriving_Json_lexer.cmo deriving_Json.cmo)
 
 include ../Makefile.conf
+-include ../Makefile.local
 
 ifneq "${DERIVING}" ""
 PA_DERIVING=syntax/pa_deriving_Json.cmo

=== debian/changelog ===
js-of-ocaml (1.0.5-1) unstable; urgency=low

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Thu, 22 Sep 2011 11:53:08 +0200

js-of-ocaml (1.0.3-1) unstable; urgency=low

  * New upstream release
    - do no longer remove examples, update debian/copyright accordingly

 -- Stéphane Glondu <glondu@debian.org>  Sat, 30 Jul 2011 18:31:12 +0200

## js-of-ocaml 1.0.6

=== Makefile ===
--- 
+++ 
@@ -2,6 +2,7 @@
 all: check_lwt compiler library doc runtime examples
 
 include Makefile.conf
+-include Makefile.local
 
 .PHONY: compiler library runtime examples check_lwt doc

=== debian/changelog ===
js-of-ocaml (1.0.6-1) unstable; urgency=low

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Thu, 29 Sep 2011 08:43:35 +0200

## js-of-ocaml 1.0.9

=== Makefile ===
--- 
+++ 
@@ -31,7 +31,7 @@
 
 VERSION := $(shell head -n 1 VERSION)
 install:
-	ocamlfind install -patch-version ${VERSION} $(LIBRARY) lib/META $(INTF) $(IMPL) $(NATIMPL) $(OTHERS)
+	ocamlfind install -patch-version ${VERSION} $(LIBRARY) lib/META $(INTF) $(IMPL) $(NATIMPL) $(OTHERS) $(DOC)
 	install -d -m 755 $(BINDIR)
 	install $(BIN) $(BINDIR)

=== compiler/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 all: $(COMPILER)
 
-OBJS=util.cmx dgraph.cmx \
+OBJS=pretty_print.cmx util.cmx dgraph.cmx \
      javascript.cmx js_output.cmx js_simpl.cmx \
      instr.cmx code.cmx primitive.cmx subst.cmx pure_fun.cmx deadcode.cmx \
      flow.cmx inline.cmx \

=== doc/Makefile ===
--- 
+++ 
@@ -1,5 +1,6 @@
 
 include ../Makefile.conf
+-include ../Makefile.local
 include ../Makefile.filelist
 
 MLIS := ${addprefix ../, ${DOC}}
@@ -12,4 +13,4 @@
 	   -d api-html -I ../lib -I ../lib/deriving_json ${MLIS}
 
 clean:
-	rm -r api-html/*
+	-rm -rf api-html/*

=== lib/Makefile ===
--- 
+++ 
@@ -1,9 +1,9 @@
 MLOBJS= js.cmo dom.cmo dom_html.cmo dom_events.cmo lwt_js.cmo firebug.cmo regexp.cmo CSS.cmo url.cmo file.cmo form.cmo xmlHttpRequest.cmo event_arrows.cmo json.cmo
 MLINTFS= $(MLOBJS:.cmo=.mli)
-COBJS= stubs.o
+COBJS= stubs$(OBJEXT)
 OBJS=$(MLOBJS) $(COBJS)
 
-JSON_OBJS=$(addprefix deriving_json/,deriving_bi_outbuf.cmo deriving_Json_lexer.cmo deriving_Json.cmo)
+JSON_OBJS=$(addprefix deriving_json/,deriving_Json_lexer.cmo deriving_Json.cmo)
 
 include ../Makefile.conf
 -include ../Makefile.local
@@ -48,7 +48,7 @@
 	ocamlfind ocamlopt -package deriving-ocsigen.syntax -syntax camlp4o -ppopt ${PA_DERIVING} -I deriving_json -c $<
 
 
-%.o: %.c
+%$(OBJEXT): %.c
 	ocamlfind ocamlc -package lwt -c $<
 
 stubs.c: $(MLOBJS:cmo=ml)

=== toplevel/Makefile ===
--- 
+++ 
@@ -5,11 +5,13 @@
 all: $(NAME).js
 
 include ../Makefile.conf
+-include ../Makefile.local
+
 COMP=../compiler/$(COMPILER)
 JSFILES=../runtime/runtime.js ../runtime/weak.js toplevel_runtime.js
 OCAMLC=ocamlfind ocamlc -package lwt,str -pp "camlp4o ../lib/syntax/pa_js.cmo" -I ../lib -I ../compiler
 STDLIB= ../lib/$(LIBNAME).cma ../compiler/compiler.cma toplevellib.cma
-
+EXPUNGE=$(shell ocamlc -where)/expunge
 # Removed gc and sys
 STDLIB_MODULES=\
   arg \
@@ -64,7 +66,7 @@
 
 $(NAME).byte: $(OBJS) ../compiler/compiler.cma
 	$(OCAMLC) -linkall -package str -linkpkg -o $@.tmp $(STDLIB) $(OBJS)
-	/usr/lib/ocaml/expunge $@.tmp $@ $(PERVASIVES)
+	$(EXPUNGE) $@.tmp $@ $(PERVASIVES)
 	rm -f $@.tmp
 
 %.cmo: %.ml

=== debian/changelog ===
js-of-ocaml (1.0.9-1) unstable; urgency=low

  * New upstream release
  * Fix FTBFS on bytecode architectures
  * Do not install plugins on architectures without natdynlink

 -- Stéphane Glondu <glondu@debian.org>  Sat, 03 Dec 2011 13:43:57 +0100

js-of-ocaml (1.0.8-1) unstable; urgency=low

  * New upstream release
  * Add libderiving-ocsigen-ocaml-dev to Build-Depends
  * Add new binary packages: js-of-ocaml, libjs-of-ocaml

 -- Stéphane Glondu <glondu@debian.org>  Tue, 29 Nov 2011 07:46:26 +0100

js-of-ocaml (1.0.7-1) unstable; urgency=low

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 22 Nov 2011 07:12:18 +0100

=== debian/watch ===
version=3
http://ocsigen.org/js_of_ocaml/install .*/js_of_ocaml-(.*)\.tar\.gz
# Upstream darcs repository:
#   http://ocsigen.org/darcs/js_of_ocaml/
#   http://ocsigen.org/darcsweb/?r=js_of_ocaml;a=summary

## js-of-ocaml 1.0.9b

=== lib/Makefile ===
--- 
+++ 
@@ -30,7 +30,7 @@
 	ocamlfind ocamlc -package camlp4.extend,camlp4.quotations -syntax camlp4o -c $<
 
 syntax/pa_deriving_Json.cmo: syntax/pa_deriving_Json.ml
-	ocamlfind ocamlc -package deriving-ocsigen,camlp4.quotations.o -syntax camlp4o -c $<
+	ocamlfind ocamlc -package deriving-ocsigen.syntax,camlp4.quotations.o -syntax camlp4o -c $<
 
 %.cmo: %.ml syntax/pa_js.cmo
 	ocamlfind ocamlc -pp "camlp4o syntax/pa_js.cmo" -package lwt -c -g $<

=== debian/changelog ===
js-of-ocaml (1.0.9b-1) unstable; urgency=low

  * New upstream release
  * Update debian/watch

 -- Stéphane Glondu <glondu@debian.org>  Sun, 01 Jan 2012 15:01:11 +0100

=== debian/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
  dh-ocaml (>= 0.9~),
  ocaml-findlib,
  liblwt-ocaml-dev (>= 2.3.0~),
+ libderiving-ocsigen-ocaml-dev (>= 0.3),
  camlp4,
  ocaml-nox (>= 3.12.0~)
 Standards-Version: 3.9.2
@@ -15,15 +16,16 @@
 Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/js-of-ocaml.git
 Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/js-of-ocaml.git
 
-Package: libjs-of-ocaml-dev
+Package: js-of-ocaml
 Architecture: any
 Depends:
+ libjs-of-ocaml-dev,
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
 Provides: ${ocaml:Provides}
 Recommends: ocaml-findlib
-Description: OCaml bytecode to JavaScript compiler
+Description: OCaml bytecode to JavaScript compiler (compiler)
  Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
  it possible to run OCaml programs in a web browser. Its key features
  are the following:
@@ -37,6 +39,54 @@
  .
  This package contains the compiler itself.
 
+Package: libjs-of-ocaml-dev
+Architecture: any
+Depends:
+ ${ocaml:Depends},
+ ${shlibs:Depends},
+ ${misc:Depends}
+Provides: ${ocaml:Provides}
+Recommends: ocaml-findlib
+Description: OCaml bytecode to JavaScript compiler (development files)
+ Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
+ it possible to run OCaml programs in a web browser. Its key features
+ are the following:
+  * the whole language, and most of the standard library are
+    supported;
+  * the generated code can be used with any web server and browser;
+  * you can use a standard installation of OCaml to compile your
+    programs. In particular, you do not have to recompile a library to
+    use it with Js_of_ocaml. You just have to link your program with a
+    specific library to interface with the browser APIs.
+ .
+ This package contains development files needed to compile server-side
+ (using regular OCaml compiler) and client-side (using Js_of_ocaml)
+ programs.
+
+Package: libjs-of-ocaml
+Architecture: any
+Depends:
+ ${ocaml:Depends},
+ ${shlibs:Depends},
+ ${misc:Depends}
+Provides: ${ocaml:Provides}
+Recommends: ocaml-findlib
+Description: OCaml bytecode to JavaScript compiler (runtime)
+ Js_of_ocaml is a compiler of OCaml bytecode to JavaScript. It makes
+ it possible to run OCaml programs in a web browser. Its key features
+ are the following:
+  * the whole language, and most of the standard library are
+    supported;
+  * the generated code can be used with any web server and browser;
+  * you can use a standard installation of OCaml to compile your
+    programs. In particular, you do not have to recompile a library to
+    use it with Js_of_ocaml. You just have to link your program with a
+    specific library to interface with the browser APIs.
+ .
+ This package contains runtime libraries that may be needed by
+ server-side programs communicating with clients compiled with
+ Js_of_ocaml using JSON.
+
 Package: libjs-of-ocaml-doc
 Section: doc
 Architecture: all

## js-of-ocaml 1.1

=== debian/changelog ===
js-of-ocaml (1.1-1) unstable; urgency=low

  * New upstream release
    - remove patch (merged upstream)

 -- Stéphane Glondu <glondu@debian.org>  Sun, 04 Mar 2012 20:30:02 +0100

## js-of-ocaml 1.1.1

=== Makefile ===
--- 
+++ 
@@ -31,7 +31,7 @@
 
 VERSION := $(shell head -n 1 VERSION)
 install:
-	ocamlfind install -patch-version ${VERSION} $(LIBRARY) lib/META $(INTF) $(IMPL) $(NATIMPL) $(OTHERS) $(DOC)
+	ocamlfind install -patch-version ${VERSION} $(LIBRARY) lib/META $(INTF) $(IMPL) $(OTHERS) $(DOC)
 	install -d -m 755 $(BINDIR)
 	install $(BIN) $(BINDIR)

=== compiler/Makefile ===
--- 
+++ 
@@ -12,10 +12,14 @@
 
 COMPOBJS=$(OBJS) main.cmx
 
-compile: $(COMPOBJS:cmx=cmo)
+$(COMPILER): compile.$(BEST)
+	mv -f $< $@
+
+.INTERMEDIATE: compile.byte compile.opt
+compile.byte: $(COMPOBJS:cmx=cmo)
 	ocamlfind ocamlc -package findlib,str -linkpkg -o $@ $^
 
-$(COMPILER): $(COMPOBJS)
+compile.opt: $(COMPOBJS)
 	ocamlfind ocamlopt -package findlib,str -linkpkg -o $@ $^
 
 compiler.cma: $(OBJS:cmx=cmo)
@@ -32,7 +36,7 @@
 
 clean:
 	rm -f *.cm[aiox] *.o
-	rm -f js_of_ocaml compile
+	rm -f js_of_ocaml compile.opt compile.byte
 
 depend:
 	ocamldep *.ml *.mli > .depend

=== lib/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-MLOBJS= js.cmo dom.cmo dom_html.cmo dom_events.cmo lwt_js.cmo firebug.cmo regexp.cmo CSS.cmo url.cmo file.cmo form.cmo xmlHttpRequest.cmo event_arrows.cmo json.cmo
+MLOBJS= js.cmo dom.cmo typed_array.cmo dom_html.cmo dom_events.cmo lwt_js.cmo firebug.cmo regexp.cmo CSS.cmo url.cmo file.cmo form.cmo xmlHttpRequest.cmo event_arrows.cmo json.cmo webGL.cmo
 MLINTFS= $(MLOBJS:.cmo=.mli)
 COBJS= stubs$(OBJEXT)
 OBJS=$(MLOBJS) $(COBJS)
@@ -10,7 +10,10 @@
 
 ifneq "${DERIVING}" ""
 PA_DERIVING=syntax/pa_deriving_Json.cmo
-DERIVING_JSON=deriving_json.cma deriving_json.cmxs
+DERIVING_JSON=deriving_json.cma
+ifeq "$(BEST)" "opt"
+DERIVING_JSON += deriving_json.cmxs
+endif
 endif
 
 all: $(LIBNAME).cma syntax/pa_js.cmo ${PA_DERIVING} ${DERIVING_JSON}

=== debian/changelog ===
js-of-ocaml (1.1.1-1) unstable; urgency=low

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sat, 17 Mar 2012 11:39:42 +0100

## js-of-ocaml 1.2

=== compiler/Makefile ===
--- 
+++ 
@@ -2,6 +2,8 @@
 include ../Makefile.conf
 
 all: $(COMPILER)
+
+PACKAGES=findlib,str,unix
 
 OBJS=pretty_print.cmx util.cmx dgraph.cmx \
      javascript.cmx js_output.cmx js_simpl.cmx \
@@ -17,10 +19,10 @@
 
 .INTERMEDIATE: compile.byte compile.opt
 compile.byte: $(COMPOBJS:cmx=cmo)
-	ocamlfind ocamlc -package findlib,str -linkpkg -o $@ $^
+	ocamlfind ocamlc -package $(PACKAGES) -linkpkg -o $@ $^
 
 compile.opt: $(COMPOBJS)
-	ocamlfind ocamlopt -package findlib,str -linkpkg -o $@ $^
+	ocamlfind ocamlopt -package $(PACKAGES) -linkpkg -o $@ $^
 
 compiler.cma: $(OBJS:cmx=cmo)
 	ocamlfind ocamlc -a -o $@ $^

=== lib/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-MLOBJS= js.cmo dom.cmo typed_array.cmo dom_html.cmo dom_events.cmo lwt_js.cmo firebug.cmo regexp.cmo CSS.cmo url.cmo file.cmo form.cmo xmlHttpRequest.cmo event_arrows.cmo json.cmo webGL.cmo
+MLOBJS= js.cmo dom.cmo typed_array.cmo dom_html.cmo file.cmo dom_events.cmo lwt_js.cmo firebug.cmo regexp.cmo CSS.cmo url.cmo form.cmo xmlHttpRequest.cmo event_arrows.cmo json.cmo webGL.cmo
 MLINTFS= $(MLOBJS:.cmo=.mli)
 COBJS= stubs$(OBJEXT)
 OBJS=$(MLOBJS) $(COBJS)

=== debian/changelog ===
js-of-ocaml (1.2-2) unstable; urgency=low

  * Update upstream changelog and version (Closes: #691257)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 14 Nov 2012 12:18:20 +0100

js-of-ocaml (1.2-1) unstable; urgency=low

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Fri, 08 Jun 2012 07:23:02 +0200

## js-of-ocaml 1.3.2

=== examples/webgl/Makefile ===
OBJS=webgl.cmo
NAME=webgl
OPTIONS=-pretty

include ../Makefile.common

=== debian/changelog ===
js-of-ocaml (1.3.2-2) unstable; urgency=low

  [ Nicolas Dandrimont ]
  * Add a manpage for js_of_ocaml

  [ Stéphane Glondu ]
  * Use format version 1.0 in debian/copyright
  * Bump Standards-Version to 3.9.4
  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Fri, 10 May 2013 11:14:25 +0200

js-of-ocaml (1.3.2-1) experimental; urgency=low

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Fri, 07 Dec 2012 20:52:08 +0100

js-of-ocaml (1.3.1-1) experimental; urgency=low

  * New upstream release
    - bump build-dependency to lwt

 -- Stéphane Glondu <glondu@debian.org>  Fri, 07 Dec 2012 17:50:36 +0100

=== debian/control ===
--- 
+++ 
@@ -7,11 +7,11 @@
  debhelper (>= 8),
  dh-ocaml (>= 0.9~),
  ocaml-findlib,
- liblwt-ocaml-dev (>= 2.3.0~),
+ liblwt-ocaml-dev (>= 2.4),
  libderiving-ocsigen-ocaml-dev (>= 0.3),
  camlp4,
  ocaml-nox (>= 3.12.0~)
-Standards-Version: 3.9.2
+Standards-Version: 3.9.4
 Homepage: http://ocsigen.org/js_of_ocaml
 Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/js-of-ocaml.git
 Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/js-of-ocaml.git

## js-of-ocaml 1.4

=== Makefile ===
--- 
+++ 
@@ -61,5 +61,6 @@
 dist:
 	rm -rf /tmp/js_of_ocaml-${VERSION} &&\
         cd /tmp &&\
-	darcs get http://ocsigen.org/darcs/js_of_ocaml/ js_of_ocaml-${VERSION} &&\
-	tar zcvf js_of_ocaml-${VERSION}.tar.gz js_of_ocaml-${VERSION} --exclude benchmarks --exclude _darcs --exclude tests
+	git clone https://github.com/ocsigen/js_of_ocaml.git js_of_ocaml-${VERSION} &&\
+	(cd js_of_ocaml-${VERSION}; git checkout 1.4) &&\
+	tar zcvf js_of_ocaml-${VERSION}.tar.gz js_of_ocaml-${VERSION} --exclude benchmarks --exclude .git --exclude tests

=== compiler/Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
      instr.cmx code.cmx primitive.cmx subst.cmx pure_fun.cmx deadcode.cmx \
      flow.cmx inline.cmx \
      tailcall.cmx freevars.cmx phisimpl.cmx \
-     linker.cmx generate.cmx parse.cmx driver.cmx
+     linker.cmx generate.cmx parse_bytecode.cmx driver.cmx
 
 COMPOBJS=$(OBJS) main.cmx

=== doc/Makefile ===

include ../Makefile.conf
-include ../Makefile.local
include ../Makefile.filelist

MLIS := ${addprefix ../, ${DOC}}

.PHONY: doc docwiki
doc: api-html/index.html
api-html/index.html: ${MLIS} api-index
	mkdir -p api-html
	ocamlfind ocamldoc -package lwt -intro api-index -html \
	   -d api-html -I ../lib -I ../lib/deriving_json ${MLIS}


docwiki: api-wiki/index.wiki
api-wiki/index.wiki: ${MLIS} api-index
	mkdir -p api-wiki
	ocamlfind ocamldoc -package lwt -intro api-index \
	   -d api-wiki -I ../lib -I ../lib/deriving_json \
	   -i $(shell ocamlfind query wikidoc) -g odoc_wiki.cma \
	   ${MLIS}

clean:
	-rm -rf api-html/* api-wiki/*

=== lib/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-MLOBJS= js.cmo dom.cmo typed_array.cmo dom_html.cmo file.cmo dom_events.cmo lwt_js.cmo firebug.cmo regexp.cmo CSS.cmo url.cmo form.cmo xmlHttpRequest.cmo event_arrows.cmo json.cmo webGL.cmo
+MLOBJS= js.cmo dom.cmo typed_array.cmo dom_html.cmo file.cmo dom_events.cmo firebug.cmo lwt_js.cmo regexp.cmo CSS.cmo url.cmo form.cmo xmlHttpRequest.cmo event_arrows.cmo lwt_js_events.cmo json.cmo webGL.cmo webSockets.cmo keycode.cmo
 MLINTFS= $(MLOBJS:.cmo=.mli)
 COBJS= stubs$(OBJEXT)
 OBJS=$(MLOBJS) $(COBJS)
@@ -13,10 +13,23 @@
 DERIVING_JSON=deriving_json.cma
 ifeq "$(BEST)" "opt"
 DERIVING_JSON += deriving_json.cmxs
+ifeq "${NATDYNLINK}" "YES"
+PA_DERIVING_NDL= syntax/pa_deriving_Json.cmx syntax/pa_deriving_Json.cmxs
+endif
 endif
 endif
 
-all: $(LIBNAME).cma syntax/pa_js.cmo ${PA_DERIVING} ${DERIVING_JSON}
+PA_JS= syntax/pa_js.cmo
+ifeq "${BEST}" "opt"
+ifeq "${NATDYNLINK}" "YES"
+PA_JS_NDL= syntax/pa_js.cmx syntax/pa_js.cmxs
+endif
+endif
+
+all: $(LIBNAME).cma \
+	${PA_JS} ${PA_JS_NDL} \
+	${PA_DERIVING} 	${PA_DERIVING_NDL} \
+	${DERIVING_JSON}
 
 $(LIBNAME).cma: $(OBJS)
 	ocamlmklib -o $(LIBNAME) $(OBJS)
@@ -32,8 +45,20 @@
 syntax/pa_js.cmo: syntax/pa_js.ml
 	ocamlfind ocamlc -package camlp4.extend,camlp4.quotations -syntax camlp4o -c $<
 
+syntax/pa_js.cmx: syntax/pa_js.ml
+	ocamlfind ocamlopt -package camlp4.extend,camlp4.quotations -syntax camlp4o -c $<
+
+syntax/pa_js.cmxs: syntax/pa_js.cmx
+	ocamlfind ocamlopt -shared -linkall -o $@ $<
+
 syntax/pa_deriving_Json.cmo: syntax/pa_deriving_Json.ml
 	ocamlfind ocamlc -package deriving-ocsigen.syntax,camlp4.quotations.o -syntax camlp4o -c $<
+
+syntax/pa_deriving_Json.cmx: syntax/pa_deriving_Json.ml
+	ocamlfind ocamlopt -package deriving-ocsigen.syntax,camlp4.quotations.o -syntax camlp4o -c $<
+
+syntax/pa_deriving_Json.cmxs: syntax/pa_deriving_Json.cmx
+	ocamlfind ocamlopt -shared -linkall -o $@ $<
 
 %.cmo: %.ml syntax/pa_js.cmo
 	ocamlfind ocamlc -pp "camlp4o syntax/pa_js.cmo" -package lwt -c -g $<

=== runtime/Makefile ===
FILES= 	mlString.js ieee_754.js int64.js md5.js marshall.js \
	lexing.js parsing.js json.js \
	stdlib.js jslib.js jslib_js_of_ocaml.js

runtime.js: $(FILES)
	cat $(FILES) > runtime.js

clean:
	rm -f runtime.js

=== toplevel/Makefile ===
--- 
+++ 
@@ -7,10 +7,16 @@
 include ../Makefile.conf
 -include ../Makefile.local
 
+ifeq ($(shell ocamlc -v | grep -q "version 4"; echo $$?),0)
+OCAMLLIB=ocamlcommon.cma ocamlbytecomp.cma ocamltoplevel.cma
+else
+OCAMLLIB=toplevellib.cma
+endif
+
 COMP=../compiler/$(COMPILER)
 JSFILES=../runtime/runtime.js ../runtime/weak.js toplevel_runtime.js
-OCAMLC=ocamlfind ocamlc -package lwt,str -pp "camlp4o ../lib/syntax/pa_js.cmo" -I ../lib -I ../compiler
-STDLIB= ../lib/$(LIBNAME).cma ../compiler/compiler.cma toplevellib.cma
+OCAMLC=ocamlfind ocamlc -package lwt,str -pp "camlp4o ../lib/syntax/pa_js.cmo" -I +compiler-libs -I ../lib -I ../compiler
+STDLIB= ../lib/$(LIBNAME).cma ../compiler/compiler.cma $(OCAMLLIB)
 EXPUNGE=$(shell ocamlc -where)/expunge
 # Removed gc and sys
 STDLIB_MODULES=\
@@ -62,7 +68,7 @@
 #	ocamlfind ocamlc -linkall -g -package str -linkpkg toplevellib.cma -o $@.tmp $^
 
 $(NAME).js: $(NAME).byte $(COMP) $(JSFILES)
-	$(COMP) -toplevel -noinline -noruntime $(JSFILES) $(NAME).byte $(OPTIONS)
+	$(COMP) -I $(shell ocamlc -where)/compiler-libs -toplevel -noinline -noruntime $(JSFILES) $(NAME).byte $(OPTIONS)
 
 $(NAME).byte: $(OBJS) ../compiler/compiler.cma
 	$(OCAMLC) -linkall -package str -linkpkg -o $@.tmp $(STDLIB) $(OBJS)

=== examples/boulderdash/Makefile ===
OBJS=boulderdash.cmo
NAME=boulderdash

include ../Makefile.common

=== examples/graph_viewer/Makefile ===
OBJS=scene.cmo viewer_common.cmo viewer_js.cmo
NAME=jsviewer

include ../Makefile.common
include .depend

=== examples/hyperbolic/Makefile ===
OBJS=hypertree.cmo
NAME=hypertree
OPTIONS=-pretty

include ../Makefile.common

=== examples/minesweeper/Makefile ===
OBJS=minesweeper.cmo main.cmo
NAME=minesweeper

include ../Makefile.common

main.cmo: minesweeper.cmo

=== examples/planet/Makefile ===
OBJS=planet.cmo
NAME=planet
OPTIONS=-pretty

include ../Makefile.common

=== examples/webgl/Makefile ===
OBJS=webgldemo.cmo
NAME=webgldemo
OPTIONS=-pretty

include ../Makefile.common

=== debian/changelog ===
js-of-ocaml (1.4-1build1) trusty; urgency=medium

  * Rebuild for new OCaml ABIs.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 03 Feb 2014 18:19:54 +0000

js-of-ocaml (1.4-1) unstable; urgency=medium

  * New upstream release
  * Update Vcs-*
  * Bump Standards-Version to 3.9.5 (no changes)

 -- Stéphane Glondu <glondu@debian.org>  Fri, 27 Dec 2013 20:20:21 +0100

js-of-ocaml (1.3.2-4) unstable; urgency=low

  * Upload to unstable

 -- Stéphane Glondu <glondu@debian.org>  Sat, 07 Dec 2013 10:42:24 +0100

js-of-ocaml (1.3.2-3) experimental; urgency=low

  * Compile with OCaml >= 4.01

 -- Stéphane Glondu <glondu@debian.org>  Mon, 11 Nov 2013 08:00:20 +0100

=== debian/control ===
--- 
+++ 
@@ -6,15 +6,15 @@
 Build-Depends:
  debhelper (>= 8),
  dh-ocaml (>= 0.9~),
- ocaml-findlib,
+ ocaml-findlib (>= 1.4),
  liblwt-ocaml-dev (>= 2.4),
  libderiving-ocsigen-ocaml-dev (>= 0.3),
  camlp4,
- ocaml-nox (>= 3.12.0~)
-Standards-Version: 3.9.4
+ ocaml-nox (>= 4.01)
+Standards-Version: 3.9.5
 Homepage: http://ocsigen.org/js_of_ocaml
-Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/js-of-ocaml.git
-Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/js-of-ocaml.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ocaml-maint/packages/js-of-ocaml.git
+Vcs-Git: git://anonscm.debian.org/pkg-ocaml-maint/packages/js-of-ocaml.git
 
 Package: js-of-ocaml
 Architecture: any
@@ -45,6 +45,8 @@
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
+Breaks: libjs-of-ocaml (<< 1.4)
+Replaces: libjs-of-ocaml (<< 1.4)
 Provides: ${ocaml:Provides}
 Recommends: ocaml-findlib
 Description: OCaml bytecode to JavaScript compiler (development files)
@@ -69,6 +71,8 @@
  ${ocaml:Depends},
  ${shlibs:Depends},
  ${misc:Depends}
+Breaks: libjs-of-ocaml-dev (<< 1.4)
+Replaces: libjs-of-ocaml-dev (<< 1.4)
 Provides: ${ocaml:Provides}
 Recommends: ocaml-findlib
 Description: OCaml bytecode to JavaScript compiler (runtime)

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DESTDIR=$(CURDIR)/debian/tmp
BINDIR=$(DESTDIR)/usr/bin
DOCDIR=$(DESTDIR)/usr/share/doc/libjs-of-ocaml-dev

include /usr/share/ocaml/ocamlvars.mk

export OCAMLFIND_DESTDIR=$(DESTDIR)/$(OCAML_STDLIB_DIR)
export OCAMLFIND_LDCONF=ignore

%:
	dh $@ --with ocaml

.PHONY: override_dh_install
override_dh_install:
	dh_install -X.so.owner --fail-missing

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress -X.js

.PHONY: override_dh_auto_build
override_dh_auto_build:
	$(MAKE) BEST=$(OCAML_BEST)

.PHONY: override_dh_auto_install
override_dh_auto_install:
	mkdir -p $(OCAMLFIND_DESTDIR) $(BINDIR) $(DESTDIR)$(OCAML_DLL_DIR)
	$(MAKE) install BINDIR=$(BINDIR) BEST=$(OCAML_BEST)
	mkdir -p $(DOCDIR)/html $(DOCDIR)/examples
	cp -a doc/api-html $(DOCDIR)/html/api
	cp -a examples/* $(DOCDIR)/examples
	rm -f $(DOCDIR)/examples/*/*.cm* $(DOCDIR)/examples/*/*.byte
ifeq ($(OCAML_NATDYNLINK),no)
	find $(DESTDIR) -name '*.cmxs' -delete
endif

.PHONY: override_dh_auto_clean
override_dh_auto_clean:
	dh_auto_clean
	-cd $(CURDIR)/doc && make clean
	rm -Rf doc/api-html/

=== debian/watch ===
version=3
http://ocsigen.org/download/js_of_ocaml-(.*)\.tar\.gz
# Upstream darcs repository:
#   http://ocsigen.org/darcs/js_of_ocaml/
#   http://ocsigen.org/darcsweb/?r=js_of_ocaml;a=summary
